!ABCIncludeFile

OMIT('_EndOfInclude_',_SarrayClPresent_)
_SarrayClPresent_ EQUATE(1)

!Other Classes
!  Include('OtherClass.INC')

!Equates - will be seen by using program

SarrayClType Class,type,module('SarrayCl.CLW'),LINK('SarrayCl.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)

!Member Data
ErrorStr string(80)
psa      long   !pointer to safe array descriptor
cDims    long   !number of dimentions
datasize long   !bytes in each data element
VariantType ushort
datalocked byte(0)
!Methods - all return 0 for success if they return anything
!pVarianttype = the variant type for the data in the array
! typical values are VT_UI1 for a byte array
! or VT_Variant (12) for an array of variants
! data size is the size of one element (1 for byte, 4 for long, 16 for variant...)
! the array index is filled with the max index for each dimention. It assumes the 1st index is 1 (not 0)
! arrIndex[1]=20 means dimention 1 can have 20 values  1...20
! if cDims is 0 then the number of dimentions is set to maximum(arrIndex) else to cDims or count of dims.
Init                  Procedure(ushort pVariantType, long pDataSize, *long[] arrIndex,long cDims=0), byte,proc
kill                  procedure(),byte,proc !dont call if you should not dispose of the safe array.
PutData               Procedure(*long[] arrIndex, long lpData, byte pLeaveLocked=0),byte
GetData               procedure(*long[] arrIndex, long lpData, byte pLeaveLocked=0),byte 

!creates a variant using the vartype and vardata passed
!the variant is then put into the array without duplicating any referenced strings (bstr typical)
!if you WANT the bstr duplicated before putting it into the array, then set pDeepCopy=true and the string is duplicated
!ArrIndex specifies the index(es) of where the data should go.
PutVariant            Procedure(*long[] arrIndex, long pVarType, long pvarData, byte pDeepCopy=0, byte pLeaveLocked=0),byte

LockData              procedure(),byte,proc
Unlockdata            procedure(),byte,proc

GetDataOne            procedure(*long[] arrIndex, long lpData),byte

Attach                procedure(long psa,ushort pvartype),byte,proc
GetDimentionCount     procedure(),LONG,proc
GetBounds             procedure(long pDim, *long lbound, *long ubound),byte,proc

!one step one-dim byte safearray to string
SafeArrayToString     Procedure(long psa, ushort vartype, *byte Res),*string
SafeArrayToQ          Procedure(long psa, ushort vartype, Queue DataQ),byte,proc
!string to a one-dim byte safearray
StringToSafeArray     procedure(*long psa, *string buf, long cbBuf),byte,proc
    end
 !_EndOfInclude_