  program
_abcdllmode_ equate(0)
_abclinkmode_ equate(1)
  map
    module('api')
    variantINIT(long),pascal,long,name('variantinit'),proc
    variantclear(long),pascal,long,name('variantclear'),proc
    end

  end
include('sarraycl.inc')
include('strcl.inc')
strcl       strcltype
SArrayCl    SarrayCltype                       !safe array class
cwstr       string('VIEW')                     !'view' - string constant to convert to bstr and put in safearray
lpbstr      long                               !pointer to a bstr after cwstr converted into a bstr
arrIndex    long,dim(1)                        !array used to pass dimention info to safe array class, 1 dim array
safearrayerror byte(0)                         !flag that safe array could not be created


!stuff to handle I dispatch
!--- dumb api contants ----
!variant types
vt_dispatch         equate(9)
vt_empty            equate(0)
vt_uI1              equate(11H)
vt_i4               equate(3)
vt_i2               equate(2)
vt_array            equate(2000H)
vt_bool             equate(11)
VT_VARIANT          EQUATE(12)
vt_bstr             equate(8)

!IID:NULL passed to invoke
IID:NULL            group !silly constant needed to call Invoke method
data1               ulong(0)
data2               ushort(0)
data3               ushort(0)
data4               string('<0><0><0><0><0><0><0><0>')
                 end
!dispatch interface
IDISPATCHTYPE       INTERFACE,COM,Type
QueryInterface      PROCEDURE (long  iid_Requested, *LONG lpInterface),long
AddRef              PROCEDURE (),Long,PROC
Release             PROCEDURE (),Long,PROC
GetTypeInfocount    Procedure(*Unsigned pctinfo),long
GetTypeInfo         Procedure(unsigned itinfo, Unsigned lcid, *long pptinfo),long
GetIdsOfNames       Procedure(long riid, long rgsznames, unsigned cnames, unsigned lcid, *long rgdispid),long
Invoke              Procedure(long dispidmember, long riid, unsigned lcid, ushort flags, long pdispparams, long pvarresult, long pexceptinfo, unsigned puArgErr),long
                 end
!parameters for invoke
dispparms           group           !used to pass parameters to a Idispatch invoke method
lparrOfargs         long
lpdispofargs        long  !0
NumArgs             long
numNamedArgs        long  !0
                end
!variant group def
VariantType         GROUP,TYPE     !variant structure
vt                  USHORT
wReserved1          USHORT
wReserved2          USHORT
wReserved3          USHORT
Value               LONG
extrapad            ULONG
  END

!---end dumb contants-----

!these variables used to call IDispatch.Invoke
Idisp               &IDispatchtype      !Idispatch interface definition and reference
cobj                cstring(20)         !used to get the address of IDispatch
var                 like(varianttype)   !variant for return result from IDispatch
varparm             group               !group of variants - used to pass up to 3 parameters
var1                like(varianttype)  !schema id not used
var2                like(Varianttype)  !safearray
var3                like(varianttype)  !adschematables=20
            end


!ado test junk
cRS cstring(20)
Idx long
count long
cFields cstring(20)
cField cstring(20)
cCmd   cstring(20)
thetype long
! Window Structure
Window               WINDOW('ado test'),AT(,,361,184),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY,DOUBLE
                       OLE,AT(37,13,70,90),USE(?CmdObj)
                       END
                       OLE,AT(155,18,71,84),USE(?RS)
                       END
                     END
!used for getting the value property on the record set object when cw fails
thevalue     long
thevaluetype long
thevaluestr  &string
thevaluestrdef string(256)
 code

!create the connection object
     open(window)
     ?cmdobj{prop:Create}='ADODB.Connection'
    ! ?cmdobj{prop:reportexception}=true
     ?cmdobj{'OPEN("DATA SOURCE=JANE;PROVIDER=SQLOLEDB.1;Initial Catalog=pubs;UID=SA;PWD=",,,)'}
     cObj=?cmdobj{prop:object}
     if cobj[1]<>'`' then message('could not connect');close(window);return.
     message(?cmdobj{'connectionstring'})

!build the safearray
     clear(safearrayerror)

     !create a one dimention safe array
     !Each element of the array is a VT_variant or a variant
     !max index value for dimention 1=4
     !16=size of a variant
     !dimention 1 can only hold 4 variants 1...4
     arrIndex[1]=4
     if SArrayCl.Init(vt_Variant,size(var),arrIndex[]) then
       message(SArrayCl.ErrorStr,'init')
         safearrayerror=true
     end

     !fill the safe array with bytes from the string 1...4 elements
     !idx 1 is vt_empty
     arrindex[1]=1
     if ~safearrayerror and SArrayCl.Putvariant(arrIndex, vt_empty,0) then
         message(SArrayCl.ErrorStr,'put')
         safearrayerror=true
     end
     !idx 2 is vt_empty
     arrindex[1]+=1
     if ~safearrayerror and SArrayCl.Putvariant(arrIndex, vt_empty,0) then
         message(SArrayCl.ErrorStr,'put')
         safearrayerror=true
     end

     !idx 3 is vt_empty
     arrindex[1]+=1
     if  ~safearrayerror and SArrayCl.Putvariant(arrIndex, vt_empty,0) then
         message(SArrayCl.ErrorStr,'put')
         safearrayerror=true
     end

     !idx 4 is a bstring pointer
     arrindex[1]+=1

     !convert to bstring and copy into array
     strcl.cwtoBstrAlloc(cwstr, lpbstr)

     if  ~safearrayerror and SArrayCl.Putvariant(arrIndex, vt_bstr,lpbstr) then
         message(SArrayCl.ErrorStr,'put')
         safearrayerror=true
     end
     !note: the put data method does not do a 'deep copy' or variantcopy of the data.
     !instead it just does a memcpy. This means the bstr pointed to by the variant is not duplicated
     !and becomes a part of the safe array. When the safe array is freed during sarraycl.kill(), then the
     !memory for the bstring is released.


     if ~SafeArrayError then
!code to start calling Idispatch invoke for the OpenSchema method - cut and paste the oleview info
!        [id(0x00000013), helpcontext(0x0012c8d8)]
!        HRESULT OpenSchema(
!                        [in] SchemaEnum Schema,
!                        [in, optional] VARIANT Restrictions,
!                        [in, optional] VARIANT SchemaID,
!                        [out, retval] _Recordset** pprset);
       IDisp&=(cobj[2 : len(cobj)]) !use the cw pointer to the idispatch interface of the dictionary

       !clear variants - 1 for return result (var) and 3 for the parameters
       variantinit(address(var))
       variantINIT(address(varparm.var1))
       variantINIT(address(varparm.var2))
       variantINIT(address(varparm.var3))

       !create variants for the parameters - 1st on the line is put at the end of the array
       ! in other words the array of variants is packed backwards
       varparm.var3.vt=vt_I4                     !1st parameter is some constant = 20
       varparm.var3.value=20
       varparm.var2.vt=vt_array+vt_variant       !2nd parameter is safe array
       varparm.var2.value=SArrayCl.psa
       varparm.var1.vt=vt_empty                  !3rd parameter is schema id and will always be empty
       varparm.var1.value=0

       !put pointer to list of variants into dispparms structure
       CLEAR(DISPPARMS)
       !dispparms.numargs=1  !just pass the constant adschematable = 1 parameter
       !dispparms.lparrofargs=address(varparm.var3)

       dispparms.numargs=2   !pass the constant and the safearray of 4 elements = 2 parameters
       dispparms.lparrofargs=address(varparm.var2)

       !013H is the dispId for open schema from oleview
       !iid:null is doppy constant
       !409H is english language
       !1=dispatch_method since this is a method
       !dispparams we just made is the parameters
       !var is where the result goes
       !0,0 is used for error info - I'm just too lazy to use it.
       hr#=Idisp.invoke(013H,address(iid:null),409H,1,Address(dispparms),address(var),0,0)

       !free the safe array and the bstring it contains no matter what
       if sarraycl.kill() then message('safe array kill error').

       !test the hresult. 0 or greater is a good result
       !also test the output variable is an IDispatch pointer and not blank
       if hr#<0 or var.vt<>vt_dispatch or ~var.value then
         message(hr#,'OpenSchema failed')

       else
         !the var variant contains a pointer to the record set
         !now we make the pointer into the format cw understands
         cRS='`'&var.value
         !message(var.vt,'ret val type')
         !Message(cRS)


           Loop  !For each record
             if ?cmdobj{crs & '.EOF'}<>0 then break.
             cFields = ?cmdobj{crs & '.FIELDS'}
             count=?cmdobj{cFields & '.Count'}
             Loop idx = 0 to count-1  !For each field
               cField=?cmdobj{cFields & '.ITEM('&idx&')'}
               thetype=?cmdobj{cfield & '.type'}

               !get the value using cw and if it fails, then get call invoke ourself to do it right
               if ?cmdobj{cfield & '.value'}='GetPropertyFailed' then
                 clear(dispparms)
                 IDisp&=(cfield[2 : len(cfield)]) !use the cw pointer to the idispatch interface of the dictionary
                 variantinit(address(var)) !clear the output varaint
                 ! 0=dispid,
                 !iid:null is dopey constant,
                 !409H=langID,
                 !2=propget,
                 ! dispparams is blank/cleared=no parameters,
                 !var is the output
                 !0,0 is error info I'm not using
                 hr#=Idisp.invoke(0H,address(iid:null),409H,2,Address(dispparms),address(var),0,0)
                 If ~hr# then
                   thevalue=var.value
                   thevaluetype=var.vt
  !todo*** this is a hack using a 256 byte string since the data could be anylength
  !  should add code to new() a string if the string isnt long enough or defined size is >256
  !in fact one of the big reasons that cw propget fails is it cant handle strings longer than 256
  !in this case though there werent any such values. the choice is to try to detect fields truncated at 256 char
  ! or just always call invoke your self and do the bstr to cw string conversion with strclass then free the bstr memory
                   thevaluestrdef=thevaluetype
                   thevaluestr&=thevaluestrdef
                   !Message('value='&thevalue & '  thetype='&thevaluetype)
  !todo***         !put code here to interpet the type and do something with the value
                   !for example if the guid is not null then write code to convert the guid to a string
                   !in this case VT_NULL is screwing up at least c5b, maybe fixed in c55?
                   if thevaluetype=1 ! = vt_NULL then
                     clear(thevalue)
                     thevaluestr='NULL'
                   end
                   Message('name='&?cmdobj{cField & '.NAME'} & '  type='& ?cmdobj{cfield & '.type'} &'  definedsize='&?cmdobj{cfield & '.definedsize'} &'  value='&thevaluestr,'Error')
                   !free any memory associated with the returned variant
                   variantclear(address(var))
                 else
                   message('propget value failed='&hr#,'failed')
                 end
               else
                 Message('name='&?cmdobj{cField & '.NAME'} & '  type='&?cmdobj{cfield & '.type'} &'  definedsize='&?cmdobj{cfield & '.definedsize'}  &'  value='& ?cmdobj{cField & '.Value'},'OK')
               end
               ?cmdobj{prop:release}=cField
             end
             ?cmdobj{prop:Release}=cFields
             ?cmdObj{crs & '.MOVENEXT'}
           end
         ?cmdobj{cRS &'.Close()'}
         ?cmdobj{prop:release}=cRS
       end
     end !safe array error
     ?cmdobj{'Close()'}  !close the connection
     !three releases only required for c5b and will cause a gpf on c55. for c5 comment out the
     ! last two calls to prop:release below.
     ?cmdobj{prop:release}=cobj
     ?cmdobj{prop:release}=cobj
     ?cmdobj{prop:release}=cobj
     close(window)
      













